                        /*** /

This file is part of Golly, a Game of Life Simulator.
Copyright (C) 2013 Andrew Trevorrow and Tomas Rokicki.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 Web site:  http://sourceforge.net/projects/golly
 Authors:   rokicki@gmail.com  andrew@trevorrow.com

                        / ***/
#ifndef RULETREEALGO_H
#define RULETREEALGO_H
#include "ghashbase.h"
/**
 *   An algorithm that uses an n-dary decision diagram.
 */
class ruletreealgo : public ghashbase {
public:
   ruletreealgo() ;
   virtual ~ruletreealgo() ;
   virtual state slowcalc(state nw, state n, state ne, state w, state c,
                          state e, state sw, state s, state se) ;
   virtual const char* setrule(const char* s) ;
   virtual const char* getrule() ;
   virtual const char* DefaultRule() ;
   virtual int NumCellStates() ;
   static void doInitializeAlgoInfo(staticAlgoInfo &) ;

   // these two methods are needed for RuleLoader algo
   bool IsDefaultRule(const char* rulename);
   const char* LoadTree(FILE* rulefile, int lineno, char endchar, const char* s);

private:
   int *a, base ;
   state *b ;
   int num_neighbors, num_states, num_nodes ;
   char rule[MAXRULESIZE] ;
};
#endif
